import{s as ce,n as ve,o as be}from"../chunks/scheduler.db6b1edd.js";import{S as we,i as xe,g as i,s as a,r as G,A as ge,h as o,f as s,c as r,j as de,u as K,x as l,k as fe,y as $e,a as n,v as N,d as Q,t as V,w as X}from"../chunks/index.ef84021a.js";import{H as Z}from"../chunks/Heading.87f70b00.js";function Te(ee){let u,P,q,j,h,M,p,te='The <a href="https://github.com/huggingface/datasets-server" rel="nofollow">Datasets Server</a> has two main components that work together to return queries about a dataset instantly:',H,m,se="<li>a user-facing web API for exploring and returning information about a dataset</li> <li>a server runs the queries ahead of time and caches them in a database</li>",L,d,ne="While most of the documentation is focused on the web API, the server is crucial because it performs all the time-consuming preprocessing and stores the results so the web API can retrieve and serve them to the user. This saves a user time because instead of generating the response every time it gets requested, Datasets Server can return the preprocessed results instantly from the cache.",S,f,ae="There are three elements that keep the server running: the job queue, workers, and the cache.",A,c,I,v,re="The job queue is a list of jobs stored in a Mongo database that should be completed by the workers. The jobs are practically identical to the endpoints the user uses; only the server runs the jobs ahead of time, and the user gets the results when they use the endpoint.",W,b,ie="There are three jobs:",E,w,oe='<li><code>/splits</code> corresponds to the <code>/splits</code> endpoint. It refreshes a dataset and then returns that dataset’s splits and configurations. For every split in the dataset, it’ll create a new job.</li> <li><code>/first-rows</code> corresponds to the <code>/first-rows</code> endpoint. It gets the first 100 rows and columns of a dataset split.</li> <li><code>/parquet</code> corresponds to the <code>/parquet</code> endpoint. It downloads the whole dataset, converts it to <a href="https://parquet.apache.org/" rel="nofollow">parquet</a> and publishes the parquet files to the Hub.</li>',z,x,le="You might’ve noticed the <code>/rows</code> and <code>/search</code> endpoints don’t have a job in the queue. The responses from these endpoints are generated on demand.",D,g,U,$,ue="Workers are responsible for executing the jobs in the queue. They complete the actual preprocessing requests, such as getting a list of splits and configurations. The workers can be controlled by configurable environment variables, like the minimum or the maximum number of rows returned by a worker or the maximum number of jobs to start per dataset user or organization.",J,T,he='Take a look at the <a href="https://github.com/huggingface/datasets-server/tree/main/services/worker#configuration" rel="nofollow">workers configuration</a> for a complete list of the environment variables if you’re interested in learning more.',F,_,O,C,pe="Once the workers complete a job, the results are stored - or <em>cached</em> - in a Mongo database. When a user makes a request with an endpoint like <code>/first-rows</code>, Datasets Server retrieves the preprocessed response from the cache, and serves it to the user. This eliminates the time a user would’ve waited if the server hadn’t already completed the job and stored the response.",R,y,me="As a result, users can get their requested information about a dataset (even large ones) nearly instantaneously!",Y,k,B;return h=new Z({props:{title:"Server infrastructure",local:"server-infrastructure",headingTag:"h1"}}),c=new Z({props:{title:"Job queue",local:"job-queue",headingTag:"h2"}}),g=new Z({props:{title:"Workers",local:"workers",headingTag:"h2"}}),_=new Z({props:{title:"Cache",local:"cache",headingTag:"h2"}}),{c(){u=i("meta"),P=a(),q=i("p"),j=a(),G(h.$$.fragment),M=a(),p=i("p"),p.innerHTML=te,H=a(),m=i("ul"),m.innerHTML=se,L=a(),d=i("p"),d.textContent=ne,S=a(),f=i("p"),f.textContent=ae,A=a(),G(c.$$.fragment),I=a(),v=i("p"),v.textContent=re,W=a(),b=i("p"),b.textContent=ie,E=a(),w=i("ul"),w.innerHTML=oe,z=a(),x=i("p"),x.innerHTML=le,D=a(),G(g.$$.fragment),U=a(),$=i("p"),$.textContent=ue,J=a(),T=i("p"),T.innerHTML=he,F=a(),G(_.$$.fragment),O=a(),C=i("p"),C.innerHTML=pe,R=a(),y=i("p"),y.textContent=me,Y=a(),k=i("p"),this.h()},l(e){const t=ge("svelte-u9bgzb",document.head);u=o(t,"META",{name:!0,content:!0}),t.forEach(s),P=r(e),q=o(e,"P",{}),de(q).forEach(s),j=r(e),K(h.$$.fragment,e),M=r(e),p=o(e,"P",{"data-svelte-h":!0}),l(p)!=="svelte-is33n6"&&(p.innerHTML=te),H=r(e),m=o(e,"UL",{"data-svelte-h":!0}),l(m)!=="svelte-12qbi16"&&(m.innerHTML=se),L=r(e),d=o(e,"P",{"data-svelte-h":!0}),l(d)!=="svelte-tuxeb9"&&(d.textContent=ne),S=r(e),f=o(e,"P",{"data-svelte-h":!0}),l(f)!=="svelte-19jmf8q"&&(f.textContent=ae),A=r(e),K(c.$$.fragment,e),I=r(e),v=o(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-1r0ezeb"&&(v.textContent=re),W=r(e),b=o(e,"P",{"data-svelte-h":!0}),l(b)!=="svelte-wyypiy"&&(b.textContent=ie),E=r(e),w=o(e,"UL",{"data-svelte-h":!0}),l(w)!=="svelte-n6lfh"&&(w.innerHTML=oe),z=r(e),x=o(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-1e44dmt"&&(x.innerHTML=le),D=r(e),K(g.$$.fragment,e),U=r(e),$=o(e,"P",{"data-svelte-h":!0}),l($)!=="svelte-7k57hi"&&($.textContent=ue),J=r(e),T=o(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-1jj7ypx"&&(T.innerHTML=he),F=r(e),K(_.$$.fragment,e),O=r(e),C=o(e,"P",{"data-svelte-h":!0}),l(C)!=="svelte-vx3101"&&(C.innerHTML=pe),R=r(e),y=o(e,"P",{"data-svelte-h":!0}),l(y)!=="svelte-l44lf6"&&(y.textContent=me),Y=r(e),k=o(e,"P",{}),de(k).forEach(s),this.h()},h(){fe(u,"name","hf:doc:metadata"),fe(u,"content",_e)},m(e,t){$e(document.head,u),n(e,P,t),n(e,q,t),n(e,j,t),N(h,e,t),n(e,M,t),n(e,p,t),n(e,H,t),n(e,m,t),n(e,L,t),n(e,d,t),n(e,S,t),n(e,f,t),n(e,A,t),N(c,e,t),n(e,I,t),n(e,v,t),n(e,W,t),n(e,b,t),n(e,E,t),n(e,w,t),n(e,z,t),n(e,x,t),n(e,D,t),N(g,e,t),n(e,U,t),n(e,$,t),n(e,J,t),n(e,T,t),n(e,F,t),N(_,e,t),n(e,O,t),n(e,C,t),n(e,R,t),n(e,y,t),n(e,Y,t),n(e,k,t),B=!0},p:ve,i(e){B||(Q(h.$$.fragment,e),Q(c.$$.fragment,e),Q(g.$$.fragment,e),Q(_.$$.fragment,e),B=!0)},o(e){V(h.$$.fragment,e),V(c.$$.fragment,e),V(g.$$.fragment,e),V(_.$$.fragment,e),B=!1},d(e){e&&(s(P),s(q),s(j),s(M),s(p),s(H),s(m),s(L),s(d),s(S),s(f),s(A),s(I),s(v),s(W),s(b),s(E),s(w),s(z),s(x),s(D),s(U),s($),s(J),s(T),s(F),s(O),s(C),s(R),s(y),s(Y),s(k)),s(u),X(h,e),X(c,e),X(g,e),X(_,e)}}}const _e='{"title":"Server infrastructure","local":"server-infrastructure","sections":[{"title":"Job queue","local":"job-queue","sections":[],"depth":2},{"title":"Workers","local":"workers","sections":[],"depth":2},{"title":"Cache","local":"cache","sections":[],"depth":2}],"depth":1}';function Ce(ee){return be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pe extends we{constructor(u){super(),xe(this,u,Ce,Te,ce,{})}}export{Pe as component};
